<?php
namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services\RelPrestacaoContaService;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO\Response\Error;    

class RelPrestacaoConta  extends  CrudWithParameterBag { 
    
    protected $utilService;
              
    public function __construct ($entityManager, Utilities\Util $utilService, RelPrestacaoContaService $PrestacaContasService, 
                                    BirtReport $birtReport, ReportService $reportService) {
        $this->entityManager     = $entityManager;
        $this->utilService       = $utilService;
        $this->PrestContaService = $PrestacaContasService;
        $this->birtReport        = $birtReport;
        $this->reportService     = $reportService;
    }
    
    public function findRelatorio(DTO\Request\Row $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        $params     = $this->PrestContaService->buildParams($conditions);
        $this->getReport($params, $response);
    }
    
    public function getReport($params, DTO\Response $response){
        try {
            $birtURL = $this->reportService->createRemoteReport('BIRT', $params['ReportName'], $params['ParametersRow']);
            $response->addDataset(new DataSet('URL',array('url'=>$birtURL)));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage() , 500));
        }
    }
    
    
}