<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Services\AProcessLogger as AProcessLogger;

class ConsolidationFileLogService extends AProcessLogger {
    
    protected $processMessages = array (
        // Group Consolidation
        'okInitgroupConsolidation'      => 'Iniciando a consolidação de Vendas.',        
        'okStockParams'                 => 'Parâmetros de Estoque buscados com sucesso.',        
        'okConsolidationPerDateTest'    => 'Consolidação por data da venda testada com sucesso.',        
        'okProductsDoHaveObs'           => 'Produtos da consolidação possuem observações.',        
        'okProductsDoNotHaveObs'        => 'Produtos da consolidação não possuem observações.',        
        'okGroupedProductsWithObs'      => 'Produtos da consolidação com as observações reunidos com sucesso.',
        'okSalesUnified'                => "Vendas unificadas com sucesso.",
        'okCheckProcessingDate'         => "Data de processamento checada pela data da venda, de acordo com a PARAVEND e PARAMESTOQUE",
        'okProcessingDateStatusTrue'    => "O status da data de processamento é verdadeiro.",
        'okProcessingDateStatusFalse'   => "O status da data de processamento é falso.",
        'okVerifyModifiedStock'         => "Implantação ou Ajuste de Estoque pela data das vendas verificado.",
        'okModifiedStockStatusTrue'     => "O status da verificação do ajuste de estoque é verdadeiro.",
        'okModifiedStockStatusFalse'    => "O status da verificação do ajuste de estoque é falso.",
        'okModifiedHasBeenFound'        => "Os dados de Ajustes de Estoque ou Implantação foram retornados.",
        'okStockHigherThanZeroTrue'     => "Operação bloqueada: Implantação ou Ajuste (último lançamento do dia) já realizada para a data informada.",
        'okStockHigherThanZeroFalse'    => "Operação aceita: Implantação ou Ajuste validados para a data informada.",
        'okGroupingConsolidation'       => "Iniciando o agrupamento de produtos para a Consolidação.",
        'okLoadedAlmoLocalEstoq'        => "Os parâmetros da loja foram carregados (CDALMOXARIFE e CDLOCALESTOQ).",
        'okNotLoadedAlmoLocalEstoq'     => "Não há parâmetros da loja para serem carregados.",
        'okSaleItemsToBeConsolidated'   => "A seguir os itens da venda que serão consolidados.",
        'okDoExistsObsOrCompProducts'   => "Existem composições ou observações para os produtos informados.",
        'okDontExistsObsOrCompProducts' => "Não existem composições ou observações para os produtos informados.",
        'okDoBlockConsolidation'        => "Há uma parametrização para bloquear consolidação de vendas para produtos inativos ou não cadastrados para a filial.",
        'okDontBlockConsolidation'      => "Não há uma parametrização para bloquear consolidação de vendas para produtos inativos ou não cadastrados para a filial.",
        'okItemsDefaultInfo'            => "Produto : \n",
        'okGetProductsObservations'     => "As observações dos produtos foram retornadas com sucesso.",
        
        // Group Products
        
        'okCheckForObsInSaleDate'       => "Verifica se há observação na data da venda.",
        'okGroupItemsByDate'            => "Agrupando os itens a serem consolidados por dia.",
        'okGroupItemsByDateVlrGrp'      => "Itens agrupados por dia.",
        'okItemHasAnObservation'        => "Há observação para este produto : ",
        'okItemHasntAnObservation'      => "Não há observação para este produto :",
        'okGroupProducts'               => "Agrupando produtos.",
        'okItemDontUseWarehouse'        => "O Item não usa almoxarifado.",
        'okItemDoUseWarehouse'          => "O Item usa almoxarifado.",
        'okItemDontUseStockLocation'    => "O Item não usa local de estoque.",
        'okItemDoUseStockLocation'      => "O Item usa local de estoque.",
        'okGetParamProdFili'            => "Busca os parâmetros da PRODFILI.",
        'okItemDontHaveObsOrComp'       => "O item não possui observações ou composições.",
        'okItemDoHaveObsOrComp'         => "O item possui observações ou composições.",   
        'okCalcItemVlrLanc'             => "Calculando o valor de lançamento do item.",   
        'okItemDontHaveObs'             => "O item não possui observações.",   
        'okSeparatedItems'              => "Se houver observações que não estão na composição principal, são tratadas como itens vendidos separadamente.",
        'okLoadItemComposition'         => "Carregando composições do item.",
        'okProductsGroupedWithSuccess'  => "Produtos agrupados com sucesso.",
        'okItemObservationsInfo'        => "Produto : ",
        'okItemsGroupedWithSuccess'     => "Os produtos foram agrupados com êxito !",
        'okProductFilter'               => "Filtro de Produto : ",
        'okConversionFactor'            => "Buscando fator de conversão do item ",
        'okReturnItemsSons'             => "Retornando items filhos.",
        'okSearchComposition'           => "Buscando por novos itens da composição.",
        'okSelectROTFABLOCAL'           => "SELECT NA ROTFABLOCAL",
        'okSelectROTFABLOCAL2'          => "De novo um SELECT NA ROTFABLOCAL"
    );
    
    protected $exceptionMessages = array (
        'exceptionIntro' => "A seguinte exceção ocorreu : \n"    
    );
    
    public function __construct () {
        $logStartDate = 'RotinaConsolidacaoRetail_'.date_create()->format('Ymd');
        $logPath = '/tmp/';
        parent::__construct( $logPath, $logStartDate );
    }
    
}